#ifndef GPIOAccess_H
#define GPIOAccess_H

#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>

#include "GPIOTypes.h"

class GPIOAccess {
    
public:
    static GPIO_Result setDirection(int pinNum, GPIO_Direction dir);
    static GPIO_Result getDirection(int pinNum, GPIO_Direction &dir);
    static GPIO_Result set(int pinNum, int value);
    static GPIO_Result get(int pinNum, int &value);
    static bool isPinUsable(int pinNum);
    static bool isAccessOk();
    
private:
    static GPIO_Result checkAndSetupAddress(unsigned long int blockBaseAddr, unsigned long int blockSize);
    static GPIO_Result checkPinAndAccess(int pin);

    static GPIO_Direction getDirectionImpl(int pinNum);
    
    static void writeReg(unsigned long int registerOffset, unsigned long int value);
    static unsigned long int readReg(unsigned long int registerOffset);

    static void setBit(unsigned long int &regVal, int bitNum, int value);
    static int getBit(unsigned long int regVal, int bitNum);

    static volatile unsigned long int *regAddress;
};

#endif
